/******************************************************************/
/*                                                                */
/* Copyright (C) 1994 - 2006, IBM, Ltd.                           */
/* All Rights Reserved                                            */
/*                                                                */
/*----------------------------------------------------------------*/
/*                                                                */
/* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE                    */
/* The copyright notice above does not evidence any               */
/* actual or intended publication of such source code.            */
/*                                                                */
/* RESTRICTED RIGHTS:                                             */
/*                                                                */
/* This file may have been supplied under a license.              */
/* It may be used, disclosed, and/or copied only as permitted     */
/* under such license agreement. Any copy must contain the        */
/* above copyright notice and this restricted rights notice.      */
/* Use, copying, and/or disclosure of the file is strictly        */
/* prohibited unless otherwise provided in the license agreement. */
/*                                                                */
/******************************************************************/

/**
********************************************************************************
*
* RelocatePerl()
*
* Function to relocate the ActivePerl package to it's installed location.
*
********************************************************************************
*/
function RelocatePerl()
{
    var perlOS = "";

    if (ncipackage.shortArch == "solaris2")
    {
        perlOS = "sun4-solaris-thread-multi";
    }
    else if (ncipackage.shortArch == "aix5")
    {
        perlOS = "aix-thread-multi";
    }
    else if (ncipackage.shortArch == "linux2x86")
    {
        perlOS = "i686-linux-thread-multi";
    }

    //
    // Set up platform specific variables
    //
    var separator = "/";
    var topLine = "#!/bin/sh";
    var perlLib = "PERL5LIB=\""
                   + GetNcHome() + "/precision/perl/lib/5.8.8/" + perlOS + ":"
                   + GetNcHome() + "/precision/perl/lib/5.8.8:"
                   + GetNcHome() + "/precision/perl/lib/site_perl/5.8.8/" + perlOS + ":"
                   + GetNcHome() + "/precision/perl/lib/site_perl/5.8.8:"
                   + GetNcHome() + "/precision/perl/lib/site_perl\"\n"
                   + "export PERL5LIB";

    var perlCmd = GetNcHome() + "/precision/perl/bin/perl";
    var perlEnv = "";

    if (ncipackage.shortArch == "win32")
    {
        separator = "\\";
        topLine = "@echo off";
        perlLib = "set PERL5LIB="
                   + GetNcHome() + "\\precision\\perl\\lib;"
                   + GetNcHome() + "\\precision\\perl\\site\\lib\n";
        perlCmd = GetNcHome() + "\\precision\\perl\\bin\\perl.exe";
        perlEnv = "path " + GetNcHome() + "\\platform\\win32\\bin;%Path%";
    }

    //
    // Now attempt to execute a script which will relocate the perl install
    //
    try
    {
        //
        // Now create a script to run the relocation of Perl
        //
        var scriptFileName = GetNcHome() + separator + "relocate_perl.bat";

        var scriptFile = Components.classes["@mozilla.org/file/local;1"].
            createInstance(Components.interfaces.nsILocalFile);
        scriptFile.initWithPath(scriptFileName);

        var scriptContents = topLine + "\n"
                           + perlEnv + "\n"
                           + perlLib + "\n"
                           + "\""+ perlCmd + "\" -e \"require ActiveState::RelocateTree; "
                           + "ActiveState::RelocateTree::relocate("
                             + "inplace => 'TRUE', "
                             + "to => '" + GetNcHome() + "/precision/perl', " 
                             + "verbose => 'TRUE');\""
                           + " > \""
                           + GetNcHome() + separator + "log" + separator
                           + "install" + separator + "ncp_relocateperl.log\" 2>&1\n";

        var foStream2 = Components.classes["@mozilla.org/network/file-output-stream;1"].
            createInstance(Components.interfaces.nsIFileOutputStream);
        foStream2.init(scriptFile, 0x02 | 0x08 | 0x20, 0777, 0); // write, create, truncate
        foStream2.write(scriptContents, scriptContents.length);
        foStream2.close();

        //
        // Now run the script.
        //
        var process = Components.classes["@mozilla.org/process/util;1"].
            createInstance(Components.interfaces.nsIProcess);
        process.init(scriptFile);

        var args = [];
        process.run(true, args, args.length);

        //
        // Finally, clean up the temporary file.
        //
        scriptFile.remove(false);
    }
    catch(e)
    {
        Log(0, e);
    }
}


